import 'package:snaxdart/snaxdart.dart';

main() {
  SNAXClient client = SNAXClient('https://cdn.snax.com', 'v1');
//  SNAXClient client = SNAXClient('http://127.0.0.1:8888', 'v1');

  // Get SNAX Node Info
  client.getInfo().then((NodeInfo nodeInfo) {
    print(nodeInfo);
  });

  // Get SNAX Abi
  client.getAbi('snax.token').then((AbiResp abi) {
    print(abi);
  });

  // Get SNAX Raw Abi
  client.getRawAbi('snax.token').then((AbiResp abi) {
    print(abi);
  });

  // Get SNAX Raw code and Abi
  client.getRawCodeAndAbi('snax.token').then((AbiResp abi) {
    print(abi);
  });

  // Get SNAX Block Info
  client.getBlock('298674').then((Block block) {
    print(block);
  });

  // Get Account Info
  client.getAccount('snax.token').then((Account account) {
    print(account);
  });

  // Get Account Actions
  client.getActions('snax.token', pos: -1, offset: -1).then((Actions actions) {
    print(actions);
  });

  // Get Transaction
  client
      .getTransaction(
          '83875faeb054ba20b20f392418e3a0002c4bb1c36cc4e3fde15cbd0963da8a15')
      .then((TransactionBlock transaction) {
    print(transaction);
  });

  // Get Accounts from public key
  client
      .getKeyAccounts('SNAX8RWQpzzMi5uFXXXAChi4dHnyxMYKKdAQ3Y3pHQTrvhzGk95LbT')
      .then((AccountNames accountNames) {
    print(accountNames);
  });

  // Get currency balance
  client
      .getCurrencyBalance('parslseed123', 'newdexpocket')
      .then((List<Holding> balance) {
    print(balance);
  });

  // Get Tables
  client.getTableRows('snax', 'snax', 'abihash').then((rows) => print(rows));
  client.getTableRow('snax', 'snax', 'abihash').then((row) => print(row));
}
